uses dos,Objects,swdos,arcview;
Type PFileCollection = ^TFileCollection;
     TFileCollection = object(TStringCollection)
                        Function KeyOf(Item:Pointer):Pointer;virtual;
                        Procedure FreeItem(Item:Pointer);virtual;
                       end;
     PListRec=^TListRec;
     TListRec=record
               Time,Size:LongInt;
               Name:PathStr;
              end;
var Disk:String;
    Number,I:Integer;
    Ch:Char;
Function NewRec(R:TArcRec):PListRec;
var P:PListRec;
begin
  GetMem(P,Length(R.Name)+9);
  P^.Time:=R.Time;
  P^.Size:=R.Size;
  P^.Name:=R.Name;
  NewRec:=P;
end;
Procedure TFileCollection.FreeItem(ITem:PointeR);
begin
 FreeMem(Item,Length(PListRec(Item)^.Name)+9);
end;
Function TFileCollection.KeyOf(Item:Pointer):Pointer;
begin
 KeyOf:=@PListRec(Item)^.Name;
end;
Function Date2Str(Time:Longint):String;
var S:String[12];
    TmpStr:String[2];
    DT:DateTime;
begin
 UnpackTime(Time,DT);
 S:=' ';
 Str(DT.Day:2,tmpStr);
 S:=S+TmpStr;
 Str(DT.Month:2,tmpStr);
 if TmpStr[1]=' ' then TmpStr[1]:='0';
 S:=S+'/'+TmpStr;
 Str(DT.Year mod 100:2,tmpStr);
 if TmpStr[1]=' ' then TmpStr[1]:='0';
 S:=S+'/'+TmpStr;
 Date2Str:=S;
end;
Procedure Help;
begin
 Writeln('Usage:');
 Writeln(#9'FILELIST disk: [number]');
 Writeln('Where disk is disk drive to list and number is sequentual number of');
 Writeln('diskette (applicable to floppy drives only)');
 Halt(127);
end;
Procedure ShutDown;far;
begin
 if ErrorAddr<>nil then
  begin
   Case ExitCode of
   1:StdWrite(StdErr,'Invalid function call');
   2:StdWrite(StdErr,'file not found');
   3:StdWrite(StdErr,'path not found');
   4:StdWrite(StdErr,'too many files open');
   5:StdWrite(StdErr,'access denied');
   203:StdWrite(StdErr,'out of memory');
   214:StdWrite(StdErr,'Too complex structure');
   else
   StdWrite(StdErr,'Unknown error');
   end;
   {$IFOPT D-}
    ErrorAddr:=nil;
   {$ENDIF}
   end;
end;
Function MakeList(A:PArchive):PCollection;
var P:PCollection;
    R:TArcRec;
begin
 P:=New(PFileCollection,Init(4,4));
 While A^.FindNext(R) do
 begin
  P^.Insert(NewRec(R));
 end;
 MakeList:=P;
end;

Procedure ScanDisk;
var S:SearchRec;
   Dir,Arc:PArchive;
   Flist:PCollection;
   R:TArcRec;
   Ch:Char;
    DskSize:Longint;
Procedure ListFile(P:PListRec);far;
var Arc:PArchive;L:PCollection;
    Shift:Integer;
Procedure TypeName(P:PListRec);far;
begin
 Writeln('':Shift,P^.Name,'':55-Length(P^.Name)-Shift,P^.Size:10,Date2Str(P^.Time));
end;
begin
 Shift:=3;
 TypeName(P);
 Arc:=OpenArchive(Disk+'\'+P^.Name);
 if Arc<>nil then
  begin
   L:=MakeList(Arc);
   Shift:=6;
   L^.ForEach(@TypeName);
   Dispose(Arc,Done);
   Dispose(L,Done);
  end;
end;
begin
 if Number>=0 then
  Writeln('Diskette N ',Number,'-----------------------------------------');

 {Search for volume label}
 FindFirst(Disk+'\*.*',VolumeID,S);
 if DosError<>0 then
    Writeln('Has no label')
 else
  begin
   if S.Name[9]='.' then delete(S.Name,9,1);
   writeln('Labelled ',S.Name);
  end;
 Repeat
  DskSize:=DiskSize(Ord(Disk[1])-Ord('@'));
  if DskSize=-1 then
   begin
    StdWrite(StdErr,'Cannot read diskette in drive '+Disk+' Retry(Y/N)');
    Repeat
     Ch:=Upcase(DosReadKey);
    Until (Ch='Y')or(ch='N');
    StdWrite(StdErr,Ch+#13#10);
    if ch='N' then exit;
   end;
 Until DskSize<>-1;
 Writeln('Size: ',DskSize);
 {Scan dos dir}
 Dir:=New(PDosDir,Init(Disk+'\',True));
 Flist:=MakeList(Dir);
 Dispose(Dir,Done);
 FList^.ForEach(@ListFile);
 Dispose(FList,Done);
 Writeln('Free space:',DiskFree(Ord(Disk[1])-Ord('@')));
end;
begin
 StdWrite(StdErr,'SoftWeyr disk lister. Version 1.00. Copyright(c) by SoftWeyr, 1995'#13#10);
 {$IFDEF MSDOS}
 SetIntVec($24,SaveInt24);
 {$ENDIF}
 ExitProc:=@ShutDown;
 if ParamCount=0 then help;
 disk:=StUpCase(ParamStr(1));
 if (Length(Disk)<>2)or(Disk[2]<>':') then
  begin
   StdWrite(StdErr,'First parameter must be disk name');
   Halt(19);
  end;
 if not (Disk[1] in ['A','B']) then
  begin
   {Non-Removable disk}
   Number:=0;
   ScanDisk;
  end
  else
  begin
   if ParamCount=1 then Number:=1 else
    Val(ParamStr(2),Number,I);
    if I<>0 then
     begin
      StdWrite(StdErr,'Second parameter must be a number');
      Halt(106);
     end;
   Repeat
    ScanDisk;
    StdWrite(StdErr,'Process another Diskette (Y/N)?');
    Repeat
     Ch:=Upcase(DosReadKey);
    Until (Ch='Y')or(ch='N');
    StdWrite(StdErr,Ch+#13#10);
    inc(Number);
   Until ch='N';
end;
end.



